//VAʐMRg[

#include	<avr/io.h>
#include	<avr/pgmspace.h>
#include	"comctrl.h"

enum E_RCV_STATUS
{
	ST_READY,
	ST_GETDATA
};

static	uint8_t	rcvState;
static	uint8_t	rcvCommand;
static	uint8_t	rcvHiLoFlag, hi4bit, lo4bit;

//Mobt@iMobt@pj
static	uint8_t	rbuf[TOTAL_BUF_SIZE] = {0};
static	uint8_t	ridx;
uint8_t	*comGetDataBuf() { return (rbuf + DATA_BUF_START_IDX); }	//f[^obt@̐擪|C^Ԃ

//Q^'A'𗚂猳̐l0`15ɕϊ
#define	ctoi(c)	((c) - 'A')

//̉4bit̐l0`15ɃQ^'A'𗚂ĕɕϊ
#define itoc(n)	('A' + ((n) & 0x0F))

//USART̎Mobt@NA
void	comUsartRcvBufClear()
{
	while (UCSR0A & (1 << RXC0)) hi4bit = UDR0;	//hi4bit̓_~[̑Ƃėp
}

//ʐMݒ
void	comInit()
{
	UBRR0 = F_CPU / 16 / BAUDRATE - 1;
	
	//UCSR0B:UCSZ02-UCSR0C:UCSZ01/00 = 011:f[^8rbg
	//UCSR0C:UMSEL01/00 = 00:񓯊, 01:(XCK)
	//UCSR0C:UPM01/00 = 00:peBȂ, 10:peB, 11:peB
	//UCSR0C:USBS0 = 0:Xgbvrbg1, 1:Xgbvrbg2
	UCSR0B	= (1 << RXEN0) | (1 << TXEN0) | (0b0 << UCSZ02);
	UCSR0C	= (0b00 << UMSEL00) | (0b00 << UPM00) | (0 << USBS0) | (0b11 << UCSZ00);
	
	comUsartRcvBufClear();
	rcvState = ST_READY;
}

//ʐMĎ^R}hf[^擾
//߂l
//ER}hM҂̏ԂłCOMCTRL_WAIT_RCVԂB
//ER}hMA
//		f[^M܂łCOMCTRL_WAIT_RCVԂB
//		f[^MAMR}hԂB
//Esȃf[^MȂǃG[COMCTRL_RET_UNKNOWN_CMDԂB
uint8_t	comPolling()
{
	//VAʐMM
	if (!(UCSR0A & (1 << RXC0))) return COMCTRL_WAIT_RCV;
	
	//Mf[^o
	uint8_t	byteData = UDR0;
	
	switch (rcvState)
	{
	case ST_READY:		//R}hM̑ҋ@
		//R}hM̂ƂāAf[^M̏
		rcvCommand = byteData;
		ridx = 0;
		rcvHiLoFlag = 0;
		rcvState = ST_GETDATA;
		break;	//Msiăf[^Ăj
		
	case ST_GETDATA:	//f[^M
		//IR[hMꍇif[^Ȃ̃R}hꍇAIR[hĂj
		if (byteData == COMCTRL_END_CODE)
		{
			rcvState = ST_READY;
			return rcvCommand;	//MR}hԂ
		}
		
		//obt@TCY𒴂f[^ʂMꍇiIR[hĂȂ󋵁BM̃~XB܂͒ʐMguj
		if (TOTAL_BUF_SIZE <= ridx)
		{
			rcvState = ST_READY;
			return COMCTRL_RET_UNKNOWN_CMD;		//ߕs\ȃR}h󂯎̂Ƃ
		}
		
		//Lȃf[^󂯎̂Ƃăobt@Ɋi[
		//f[^́A1byte̒lʁ^4bitɕAHƂđĂ
		if (rcvHiLoFlag == 0)
		{
			hi4bit = ctoi(byteData);
			rcvHiLoFlag = 1;
		}
		else
		{
			lo4bit = ctoi(byteData);
			rbuf[ridx++] = (hi4bit << 4) | lo4bit;
			rcvHiLoFlag = 0;
		}
		break;	//Ms
		
	default:	break;
	}
	
	//f[^M𑱍s
	return COMCTRL_WAIT_RCV;
}

//Mf[^obt@̎wʒu擾
uint8_t	comGetByteData(uint8_t idx)
{
	return rbuf[DATA_BUF_START_IDX + idx];
}

//Mobt@ŚiR}hobt@{f[^obt@j̎wʒuwordl擾
static uint16_t	comGetWordValue(uint16_t idx)
{
	uint16_t hiByte = (uint16_t)rbuf[idx];
	uint16_t loByte = (uint16_t)rbuf[idx + 1];
	return (hiByte << 8) | loByte;
}

//Mf[^obt@̎wʒuwordl擾
uint16_t	comGetWordData(uint8_t idx)
{
	return comGetWordValue(DATA_BUF_START_IDX + idx);
}

uint16_t	comGetMemAdrs()
{
	return comGetWordValue(CMD_BUF_START_IDX);
}

uint16_t	comGetDataLength()
{
	return comGetWordValue(CMD_BUF_START_IDX + 2);
}

//USART̑Mobt@1byteށizXg֑Mj
void	comSendByte(uint8_t data)
{
	while (!(UCSR0A & (1 << UDRE0))) {}	//Mobt@̋󂫑҂
	UDR0 = data;
}

void	comSendWord(uint16_t data)
{
	comSendByte((data >> 8) & 0xFF);
	comSendByte(data & 0xFF);
}

//WHOR}hɑ΂ԐM
void	comSendMyName()
{
	const char *name = PSTR(COMCTRL_MY_NAME);
	uint8_t	c;
	while ((c = pgm_read_byte(name++)) != '\0') comSendByte(c);
}
