//	I2C-EEPROMCu
//	wt]xH쎺	http://jsdiy.web.fc2.com
/*
yXVz
2013/09/30	v1.00	
*/

#include <avr/io.h>
#include "twilib.h"
#include "i2ceeprom.h"

//X[ufoCX̃AhX(4bit+3bit)
#define CHIP_CTRL_CODE	(0b1010 << 4)

#define HiByte(w)	(((w) >> 8) & 0xFF)
#define LoByte(w)	((w) & 0xFF)

TI2CEepRom* dev;

//foCX̍\̂
//	device:	foCX\
//		chipSelectBits:	EEPROM̃`bvZNgrbgBA2-A1-A0̏Ƀrbgw肵3bit̒l
//		memorySizeKByte:	EEPROM̃TCYBKBytePʂ̒l
//		pageSizeByte:	EEPROM1y[W̃TCYBbytePʂ̒l
//
//memorySizeKByte̗
//	128Kbit= 16KByte(adrs:0-0x3FFF)  memorySizeKByte=16
//	512Kbit= 64KByte(adrs:0-0xFFFF)  memorySizeKByte=64
//	  1Mbit=128KByte(adrs:0-0xFFFF x2block)  memorySizeKByte=64ƂAdevice2`ichipSelectBitsɈႢj
//͂ǂn[hEFAɊւlȂ̂ŁAf[^V[gQƂ邱ƁB
void	I2CEEPROM_DeviceInfo(TI2CEepRom* device, uint8_t chipSelectBits, uint8_t memorySizeKByte, uint8_t pageSizeByte)
{
	device->devAdrs = CHIP_CTRL_CODE | (chipSelectBits << 1);	//I2CoX̃foCXAhX
	device->memAdrsLast = (memorySizeKByte - 1) * 1024 + 1023;	//̃AhXiUINT16_MAX𒴂Ȃ悤ɎZoj
	device->pageSizeByte = pageSizeByte;
}

//ΏۂƂfoCX\̂Zbg
void	I2CEEPROM_SetDevice(TI2CEepRom* device)
{
	dev = device;
}

//ݕŃX^[g𑗐M
//	memAdrs: EEPROM̃AhX
//߂l	0:, 0:s
static	uint8_t	StartSequence(uint16_t memAdrs)
{
	uint8_t isOK, count = 0xFF;
	
	//AhẌ斖wĂG[Ƃ
	if (dev->memAdrsLast < UINT16_MAX && dev->memAdrsLast < memAdrs) return 0;
	
	//OɏݏĂꍇACK|[O˂
	do
	{
		if (!TWI_Start()) return 0;
		isOK = TWI_SlaveAddrW(dev->devAdrs);
	}
	while (!isOK && --count > 0);
	if (!isOK) goto ERROR_END;	//񐔃|[OĂACKԂĂȂ

	//SLA+WMɑ΂ACKԂĂEEPROM͏OKƂƂȂ̂ŁAV[PX𑱍s
	if (!TWI_WriteByte(HiByte(memAdrs))) goto ERROR_END;
	if (!TWI_WriteByte(LoByte(memAdrs))) goto ERROR_END;
	return 1;
	
ERROR_END:
	TWI_Stop();
	return 0;
}

//Cӂ̈ʒuɏ
//	memAdrs: EEPROM̃AhX
//		data:	 ރf[^
//߂l	0:, 0:s
uint8_t	I2CEEPROM_WriteByte(uint16_t memAdrs, uint8_t data)
{
	uint8_t isOK;
	if (!StartSequence(memAdrs)) return 0;
	isOK = TWI_WriteByte(data);
	TWI_Stop();
	return isOK;
}

//Cӂ̈ʒu畡oCgꊇŏ
//	memAdrs: EEPROM̃AhX
//		data[]:	 ޒli[ꂽz
//		length:	 ޒ	c(*)
//߂l:	񂾒	(펞: n==length, s: 0<=n<lengthj
//
//(*)c1MbitEEPROM512Kbit(64KByte)̃ubN2ō\ĂB
//1ubNŜꊇŏނƂȂ΁Alengthw0x10000i64Ljuint16_t^͈̔͂𒴂Ă܂B
//64Lvf̔z񂪗pӂ邱Ƃ͂܂Ȃ̂ŁAIɂ̖͖łB
uint16_t	I2CEEPROM_WriteBlock(uint16_t memAdrs, uint8_t data[], uint16_t length)
{
	uint16_t didx, didxLast = length - 1, doneCount = 0;
	uint16_t adrs, adrsMod;
	uint8_t doStart, doStop, isOK = 1;	//tO(1/0)
	
	for (adrs = memAdrs, didx = 0; adrs <= dev->memAdrsLast && didx <= didxLast && isOK; adrs++, didx++)
	{
		adrsMod = adrs % dev->pageSizeByte;
		doStart = (adrsMod == 0 || didx == 0);
		doStop = (adrsMod == dev->pageSizeByte - 1 || didx == didxLast);
		
		if (doStart)
		{
			isOK = StartSequence(adrs);
			if (!isOK) break;
		}
		
		isOK = TWI_WriteByte(data[didx]);
		if (isOK) doneCount++;
		
		if (doStop || !isOK) TWI_Stop();
	}
	
	return doneCount;
}

#define TWI_READDATA_CONTINUE_ACK	1	//ACK...  TWCR:(1<<TWEA)
#define TWI_READDATA_LAST_NACK		0	//NACK... TWCR:(0<<TWEA)

//ǂݍ݊֐s̐ۂmF
//߂l	0:, 0:s
static uint8_t gIsReadSuccess = 0;
uint8_t	I2CEEPROM_IsReadSuccess(){ return gIsReadSuccess; }

//݂̈ʒuǂݍ񂾌Äʒuֈړ
//߂l:	ǂݍ񂾒l
//
//EEEPROM̃AhXJE^ݎwĂʒuiO̓ǂݏ̎̈ʒuj̃f[^擾B
//Ȇ삪ƂAAhXJE^͎̈ʒuwĂB
//	]āȂĂяoƂɃf[^擾łiꊇǂݍ݂ɔׂČ͈jB
//Eړ̈ʒuAhX̖I[o[ꍇA擪AhX(0x0000)ɔŏ͑sB
uint8_t	I2CEEPROM_ReadByteAndNext()
{
	uint8_t data = 0x00;
	uint8_t isOK, count = 0xFF;
	gIsReadSuccess = 0;
	
	//OɏݏĂꍇACK|[O˂
	do
	{
		if (!TWI_Start()) return data;
		isOK = TWI_SlaveAddrR(dev->devAdrs);
	}
	while (!isOK && --count > 0);
	if (!isOK) goto ERROR_END;	//񐔃|[OĂACKԂĂȂ

	gIsReadSuccess = TWI_ReadByte(TWI_READDATA_LAST_NACK, &data);

ERROR_END:
	TWI_Stop();
	return data;
}

//Cӂ̈ʒuǂݍ
//	memAdrs: EEPROM̃AhX
//߂l:	ǂݍ񂾒l
//
//E܂AݑƂĈʒuw肷BEEPROM̃AhXJE^ړÏʒuwB
//EɁA܂Ɍ݂̈ʒuǂݍށBړÏʒũf[^ǂݍ܂B
//EAhXJE^͎̈ʒuwB
uint8_t	I2CEEPROM_ReadByte(uint16_t memAdrs)
{
	gIsReadSuccess = 0;
	if (!StartSequence(memAdrs)) return 0x00;
	return I2CEEPROM_ReadByteAndNext();
}

//Cӂ̈ʒu畡oCgꊇœǂݍ
//	memAdrs: EEPROM̃AhX
//		data[]:	 ǂݍ񂾒li[z
//		length:	 ǂݍޒ
//߂l:	ǂݍ񂾒	(펞: n==length, s: 0<=n<lengthj
//
//E܂AݑƂĈʒuw肷BEEPROM̃AhXJE^ړÏʒuwB
//EɁA܂Ɍ݂̈ʒuǂݍށBړÏʒũf[^ǂݍ܂B
//	ŁAf[^ǂݍ݂𑱂ꍇACKԂBǂݍ񂾃f[^ŌƂꍇNACKԂB
//Ef[^1ǂݍނƂɃAhXJE^͎̈ʒuwB
//	ʒuAhX̖I[o[ꍇA擪AhX(0x0000)ɔŏ͑sB
uint16_t	I2CEEPROM_ReadBlock(uint16_t memAdrs, uint8_t data[], uint16_t length)
{
	uint16_t w, doneCount = 0;
	uint8_t ackFlag;
	gIsReadSuccess = 0;
	
	if (!StartSequence(memAdrs)) return 0;
		
	if (!TWI_Start()) return 0;
	if (!TWI_SlaveAddrR(dev->devAdrs)) return 0;
	for (w = 0; w < length; w++)
	{
		ackFlag = (w + 1 == length) ? TWI_READDATA_LAST_NACK : TWI_READDATA_CONTINUE_ACK;
		gIsReadSuccess = TWI_ReadByte(ackFlag, &data[w]);
		if (gIsReadSuccess) doneCount++;
		else break;
	}
	TWI_Stop();
	
	return doneCount;
}

//̈Ŝw̃p^[Ŗ߂ij
//	pageData[]:	1y[W̒li[ꂽz
//߂l	0:, 0:s
//
//Ez̎̂1y[WȏmۂĂĂ\ȂB̊֐ł1y[W̒QƂȂB
//Ez̓eɂċ̓Iɂ́A
//	0xFF,0xFF,0xFF,cA0x01,0x01,0x01,cÂ悤1̒lŖ߂ĂA
//	0x00,0x80,0x00,0x80,ĉ悤ɓ̃p^[Ŗ߂ĂA
//	܂́A_ȒlŖ߂ĂĂ悢B
uint8_t	I2CEEPROM_Erase(uint8_t pageData[])
{
	//ǂݍ݁Aw̃p^[ƏƍA1y[WׂĈvĂ΂̃y[Wւ͏܂ȂB
	//ߖ̂1byteǂݍށB1y[W̃obt@mۂĂ܂Ƃ߂ēǂݍނƂ͂ȂB
	
	uint16_t pageAdrs, didx;
	uint8_t data;
	
	for (pageAdrs = 0; ; pageAdrs += dev->pageSizeByte)
	{
		for (didx = 0; didx < dev->pageSizeByte; didx++)
		{
			data = (didx == 0) ? I2CEEPROM_ReadByte(pageAdrs) : I2CEEPROM_ReadByteAndNext();
			if (!I2CEEPROM_IsReadSuccess()) return 0;
			if (data == pageData[didx]) continue;
			
			//ǂݍ񂾒lƔz̒lvĂȂ̂ŁAy[W݂
			if (!I2CEEPROM_WriteBlock(pageAdrs, pageData, dev->pageSizeByte)) return 0;
			break;	//̃y[W̃XLI
		}
		
		//ŏIy[Wꍇ̓[vI
		//Edev->memAdrsLast0xFFFF̃foCX̏ꍇAŏIy[W(pageAdrs += dev->pageSizeByte)
		//	pageAdrs0xFFFF(=UINT16_MAX)𒴂Ă܂B@ŏI𔻒肷KvB
		if (pageAdrs + (dev->pageSizeByte - 1) == dev->memAdrsLast) break;
	}
	
	return 1;
}
